// 
//

#include "stdafx.h"
#include "..\common\MyHash.h"
#include "chx.h"

DWORD MakeBitmap(MyVarMem* pBody, MyVarMem* pRes);

//*****************************************************************************
//
// fhChx
//	@etail
//		CGI[gDoc[gzɂ邱ƂKvƂȂ܂
//		Ƃ ../<cgiroot>/cgi.cgiȂǂ͔F܂
//		Ăяoɂ..͎gȂ
//
//		ԓ͕KCRLFŉs܂B
//		sڂ́uContent-Type: vLqĂB
//
// ----------------------------------------------------------------------------
//
//	@param
//		MyHash*		pEnv		ϐ܂
//		MyVarMem*	pBody		POSTꂽꍇANGXg{fB܂
//		MyVarMem*	pRes		NCAgɕԂeǉ܂
//
//	@return
//		pResɋlߍ񂾃oCgԂĂB
//
//*****************************************************************************
int fnChx(MyHash* pEnv, MyVarMem* pBody, MyVarMem* pRes)
{
	return MakeBitmap(pBody, pRes);
}

// ----------------------------------------------------------------------------
// G[\
// ----------------------------------------------------------------------------
void Error(MyVarMem* pRes, char* pszErrorString)
{
	pRes->Clear();
	pRes->Add("Content-Type: text/html\r\n\r\n");
	pRes->Add("<HTML><BODY>");
	pRes->Add(pszErrorString);
	pRes->Add("</BODY></HTML>");
}

// ----------------------------------------------------------------------------
// C
// ----------------------------------------------------------------------------
DWORD MakeBitmap(MyVarMem* pBody, MyVarMem* pRes)
{
	CRITICAL_SECTION csMyCriticalSection;
	InitializeCriticalSection (&csMyCriticalSection);
	EnterCriticalSection (&csMyCriticalSection);


	DWORD	dwBmpFileSize;
	
	LPVOID lpBufl;
	HDC hdc,hdcMem;
	HBITMAP hBMP, hOldBMP;

    LPBITMAPFILEHEADER pHead;
	LPBITMAPINFOHEADER pInfoHead;
	LPBYTE lpPixell;

	LPBYTE lpBMP;

	DWORD dwWidth,dwHeight, dwLength;			

	// fBXNgbṽfoCXReLXg擾
	hdc = GetWindowDC(NULL);

	// ʂ̑傫擾
	dwWidth=GetDeviceCaps(hdc,HORZRES);
	dwHeight=GetDeviceCaps(hdc,VERTRES);
	
	// TCYvZAACg𒲐
	if ((dwWidth*3) % 4 == 0)
		dwLength = dwWidth * 3;
	else
		dwLength = dwWidth * 3 + (4 - (dwWidth * 3) % 4);

	// t@Cۑpm
	dwBmpFileSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + (dwLength * dwHeight);
	//if( (lpBufl = LocalAlloc(LPTR, dwBmpFileSize )) == NULL )
	if( (lpBufl = malloc( dwBmpFileSize )) == NULL )
	{
		Error(pRes, "Memory alloc error");
		return pRes->GetLength();
	}
	
	// C[Wp|C^ݒ
	pHead = (LPBITMAPFILEHEADER)lpBufl;
	pInfoHead = (LPBITMAPINFOHEADER)((LPBYTE)lpBufl + sizeof(BITMAPFILEHEADER));
	lpPixell = (LPBYTE)lpBufl + sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

	
	// rbg}bṽwb_쐬
	BITMAPFILEHEADER	fileHead;
	fileHead.bfOffBits	= sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
	fileHead.bfSize		= dwBmpFileSize;
	fileHead.bfType		= 'M'*256+'B';
	fileHead.bfReserved1= 0;
	fileHead.bfReserved2= 0;
	//memcpy( pHead, &fileHead, sizeof(BITMAPFILEHEADER));

	BITMAPINFOHEADER infoHead;
	memset(&infoHead, 0, sizeof(BITMAPINFOHEADER));
	infoHead.biSize				= sizeof(BITMAPINFOHEADER);
	infoHead.biWidth			= dwWidth;
	infoHead.biHeight			= dwHeight;
	infoHead.biPlanes			= 1;
	infoHead.biBitCount			= 24;
	infoHead.biCompression		= BI_RGB;
	infoHead.biSizeImage		= dwLength * dwHeight;
	infoHead.biXPelsPerMeter	= 0;
	infoHead.biYPelsPerMeter	= 0;
	infoHead.biClrUsed			= 0;
	infoHead.biClrImportant		= 0;
	//memcpy( pInfoHead, &infoHead, sizeof(BITMAPINFOHEADER));

	memcpy( pHead, &fileHead, sizeof(BITMAPFILEHEADER));
	memcpy( pInfoHead, &infoHead, sizeof(BITMAPINFOHEADER));


	// DIB ƉʂDC DIBSection 쐬
	//hBMP = CreateDIBSection(hdc, (BITMAPINFO*)pInfoHead, DIB_RGB_COLORS, (void**)&lpBMP, NULL, 0); //<-MIPSŒ
	hBMP = CreateDIBSection(hdc, (BITMAPINFO*)&infoHead, DIB_RGB_COLORS, (void**)&lpBMP, NULL, 0);
	hdcMem = CreateCompatibleDC(hdc);

	if( (hOldBMP = (HBITMAP)SelectObject(hdcMem,hBMP) )== NULL )
	{
		DeleteObject(hBMP);
		DeleteDC(hdcMem);
		
		free(lpBufl);
		Error(pRes, "SelectObject error");
		return pRes->GetLength();
	}

	// ʑŜDIBSection ̃rbg}bvɃRs[
	BitBlt(hdcMem, 0, 0, dwWidth, dwHeight, hdc, 0, 0, SRCCOPY);

	// rbg}bṽRs[
	memcpy(lpPixell, lpBMP, dwLength * dwHeight);

	// GDIIuWFNg̍폜
	SelectObject(hdcMem, hOldBMP);
	DeleteObject(hBMP);
	DeleteDC(hdcMem);
	ReleaseDC(NULL, hdc);


	// I
	char szContentsLength[64];
	pRes->Add("Content-Type: image/bmp\r\n");
	sprintf(szContentsLength, "Content-Length: %d\r\n", dwBmpFileSize);
	pRes->Add(szContentsLength);

	pRes->Add("\r\n");

	if( 0 == pRes->Add(lpBufl, dwBmpFileSize ) )
	{
		Error(pRes, "Error memory not enough.");
	}

	free(lpBufl);

	LeaveCriticalSection (&csMyCriticalSection);

	return pRes->GetLength();
}


//*****************************************************************************
//
// DllMain
//
//*****************************************************************************
BOOL APIENTRY DllMain(
	HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}
